#include "ft5426.h"
#include "xpt2046.h"
#include "touch.h"
#include "string.h" 
#include "lcd.h"
#include "main.h"

/*********************************************************************************
********************* STM32F407Ӧÿ()*************************
**********************************************************************************
* ļ: ft5426.c                                                             *
* ļ                                                   *
* ڣ2018.08.30                                                           *
*     V1.0                                                                 *
*     ߣClever                                                               *
* ˵                                                                         * 
**********************************************************************************
*********************************************************************************/
	 
// 0X03	  //һݵַ
// 0X09		//ڶݵַ
// 0X0F		//ݵַ
// 0X15		//ĸݵַ
// 0X1B		//ݵַ 
const u16 FT5426_Touch_Addr[5]={0X03,0X09,0X0F,0X15,0X1B};
const u16 Touch_Point_COLOR[5]={RED,BLUE,BLACK,GREEN,YELLOW}; //5㴥ضӦɫֵ 
 

/*******************************************************************************
*************************ΪIOģIICͨ**********************************
*******************************************************************************/
//FT5426оƬIICӿڳʼ
void FT_IIC_Init(void)
{			
  GPIO_InitTypeDef  GPIO_InitStructure;	
	
	  __HAL_RCC_GPIOA_CLK_ENABLE();           //GPIOEʱ
	 	__HAL_RCC_GPIOB_CLK_ENABLE();           //GPIOEʱ
	
    GPIO_InitStructure.Pin=GPIO_PIN_5; //A5
    GPIO_InitStructure.Mode=GPIO_MODE_OUTPUT_PP;  //
    GPIO_InitStructure.Pull=GPIO_PULLUP;          //
    GPIO_InitStructure.Speed=GPIO_SPEED_HIGH;     //
    HAL_GPIO_Init(GPIOA,&GPIO_InitStructure);
		
   GPIO_InitStructure.Pin=GPIO_PIN_1; //B1   
	 HAL_GPIO_Init(GPIOB, &GPIO_InitStructure); 

	 FT_IIC_Stop();
}

//SDAΪ
void FT_IICSDA_IN(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
	  __HAL_RCC_GPIOB_CLK_ENABLE();           //GPIOBʱ
	
    GPIO_InitStructure.Pin=GPIO_PIN_1; //B1
    GPIO_InitStructure.Mode=GPIO_MODE_INPUT;  // 
    HAL_GPIO_Init(GPIOB, &GPIO_InitStructure);    
}	

//SDAΪ
void FT_IICSDA_OUT()
{
    GPIO_InitTypeDef  GPIO_InitStructure;
	  __HAL_RCC_GPIOB_CLK_ENABLE();           //GPIOBʱ
	
    GPIO_InitStructure.Pin=GPIO_PIN_1; //B1
    GPIO_InitStructure.Mode=GPIO_MODE_OUTPUT_PP;  // 
    HAL_GPIO_Init(GPIOB, &GPIO_InitStructure);    
}

//IICʼź
void FT_IIC_Start(void)
{
	FT_IICSDA_OUT();      
	FT_IIC_SDAOUT=1;	  	  
	FT_IIC_SCL=1;
	delay_us(28);
 	FT_IIC_SDAOUT=0; 
	delay_us(2);
	FT_IIC_SCL=0; 
}	 

//IICֹͣź
void FT_IIC_Stop(void)
{
	FT_IICSDA_OUT(); 
	FT_IIC_SCL=1;
	delay_us(28);
	FT_IIC_SDAOUT=0; 
  delay_us(2);
	FT_IIC_SDAOUT=1; 
}

/****************************************************************************
*     : u8 FT_MCU_WaitAck(void)
*     ܣȴӦź
* ڲ
* ز: 1Ӧʧ
            0Ӧɹ  
* ˵           
****************************************************************************/ 
u8 FT_MCU_WaitAck(void)
{
	u8 ack=0;
	
	FT_IICSDA_IN();       
	FT_IIC_SDAOUT=1;	   
	FT_IIC_SCL=1;
	delay_us(2);
	if(FT_IIC_SDAIN)
	{
    ack = 1;
	}
	else
	{
	  ack = 0;
	}
	FT_IIC_SCL=0; 
	delay_us(2);
	return ack;  
} 

//ACKӦ
void FT_MCU_Send_Ack(void)
{
	FT_IIC_SCL=0;
	FT_IICSDA_OUT();
	delay_us(2);
	FT_IIC_SDAOUT=0;
	delay_us(2);
	FT_IIC_SCL=1;
	delay_us(2);
	FT_IIC_SCL=0;
}

//ACKӦ		    
void FT_MCU_NOAck(void)
{
	FT_IIC_SCL=0;
	FT_IICSDA_OUT();
	delay_us(2);
	FT_IIC_SDAOUT=1;
	delay_us(2);
	FT_IIC_SCL=1;
	delay_us(2);
	FT_IIC_SCL=0;
}	

/****************************************************************************
*     : void FT_IIC_write_OneByte(u8 send_date)
*     ܣIICдһֽ
* ڲsend_date͵
* ز: 1Ӧ 
            0Ӧ  
* ˵           
****************************************************************************/ 	  
void FT_IIC_write_OneByte(u8 send_date)
{                        
  u8 i;   

	FT_IICSDA_OUT(); 	      
	FT_IIC_SCL=0;  
	delay_us(2);
	for(i=0;i<8;i++)
    {              
      FT_IIC_SDAOUT=(send_date&0x80)>>7;
      send_date<<=1; 	      
		  FT_IIC_SCL=1; 
		  delay_us(2);
		  FT_IIC_SCL=0;	
		  delay_us(2);
    }	 
} 

/****************************************************************************
*     : void FT_IIC_write_OneByte(u8 send_date)
*     ܣIICһֽ
* ڲack1ACK
                 0nACK 
* ز:  
* ˵           
****************************************************************************/ 
u8 FT_IIC_Read_OneByte(u8 ack)
{
	u8 i;
	u8 receivedata=0;
 	
	FT_IICSDA_IN(); 
	delay_us(28);
	for(i=0;i<8;i++ )
	{ 
		FT_IIC_SCL=0; 	    	   
		delay_us(2);
		FT_IIC_SCL=1;	 
		receivedata<<=1;
		if(FT_IIC_SDAIN)
			 receivedata++;   
	}	  				 
	if(!ack) 
		 FT_MCU_NOAck();  
	else 
		 FT_MCU_Send_Ack();  
 	return receivedata;
}
/*******************************IOģIIC*************************************
*******************************************************************************/


/****************************************************************************
*     : void FT5426_WriteReg(u16 FT_reg,u8 date)
*     ܣFT5426ӦĴд
* ڲFT_regĴ
            date  д
* ز: 
* ˵           
****************************************************************************/
void FT5426_WriteReg(u16 FT_reg,u8 date)
{
	FT_IIC_Start();	 
	FT_IIC_write_OneByte(FT_WR_CMD);	 //д 	 
	FT_MCU_WaitAck(); 	 										  		   
	FT_IIC_write_OneByte(FT_reg&0XFF); //8λַ
	FT_MCU_WaitAck();     
  FT_IIC_write_OneByte(date);        //
	FT_MCU_WaitAck();
  FT_IIC_Stop();					  
}

/****************************************************************************
*     : u8 FT5426_ReadReg(u16 FT_reg)
*     ܣFT5426ӦĴе
* ڲFT_regĴ
* ز: 
* ˵           
****************************************************************************/		  
u8 FT5426_ReadReg(u16 FT_reg)
{
	u8 date; 
	
 	FT_IIC_Start();	
 	FT_IIC_write_OneByte(FT_WR_CMD);   	 //д 	 
	FT_MCU_WaitAck(); 	 										  		   
 	FT_IIC_write_OneByte(FT_reg&0XFF);   //8λַ
	FT_MCU_WaitAck();  
 	FT_IIC_Start();  	 	   
	FT_IIC_write_OneByte(FT_RD_CMD);   	 //		   
	FT_MCU_WaitAck();	      
  date=FT_IIC_Read_OneByte(0);         //	  
  FT_IIC_Stop();  
	return date;
} 

/****************************************************************************
*     : void Read_Touch_Point(u16 addr,u8 *pBuffer)
*     ܣ4Ĵ
* ڲaddr׸Ĵ 
            pBufferŶĸĴ
* ز: 
* ˵           
****************************************************************************/	
void Read_Touch_Point(u16 addr,u8 *pBuffer)
{
 u8 i;
	for(i=0;i<4;i++)
	{
	  *pBuffer++=FT5426_ReadReg(addr+i);
	}
}

//ʼFT5426
void FT5426_Init(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;
	  __HAL_RCC_GPIOB_CLK_ENABLE();           //GPIOBʱ
  	__HAL_RCC_GPIOF_CLK_ENABLE();           //GPIOFʱ
	
    GPIO_InitStructure.Pin=GPIO_PIN_11; //A5
    GPIO_InitStructure.Mode=GPIO_MODE_INPUT;  //ģʽ
    GPIO_InitStructure.Pull=GPIO_PULLUP;          //
    GPIO_InitStructure.Speed=GPIO_SPEED_HIGH;     //
    HAL_GPIO_Init(GPIOF,&GPIO_InitStructure);

		
    GPIO_InitStructure.Pin=GPIO_PIN_0; //A5
    GPIO_InitStructure.Mode=GPIO_MODE_OUTPUT_PP;  //
    HAL_GPIO_Init(GPIOB,&GPIO_InitStructure);
	
	FT_IIC_Init();   
	
	FT_RST=0;				 //λ	
	HAL_Delay(25);
 	FT_RST=1;				    
	HAL_Delay(50);  	

  FT5426_WriteReg(0x00,0);	  //״̬ 0:ģʽ
	FT5426_WriteReg(0xA4,1);		//1:жģʽ 	 0:ѯģʽ					 
	FT5426_WriteReg(0x80,18);	  //ЧֵΪ18	ԽСԽ						
	FT5426_WriteReg(0x88,12);   // С12,14
}

u8 Touch_num;  //Ч  5
/****************************************************************************
*     : void FT5426_Scan(void)
*     ܣFT5426ɨ躯
* ڲ
* ز: 
* ˵           
****************************************************************************/ 
void FT5426_Scan(void)
{
	u8 touch_buf[4];
	u8 i=0;
	u8 j=0;
  u8 num;
	
	if(FT_INT==0)  //д
	{
		Touch_num=FT5426_ReadReg(FT_Read_TouchNum_REG); //ȡЧĸ
    num=Touch_num;
		
		for(i=0;i<num;i++)
			{				
				Read_Touch_Point(FT5426_Touch_Addr[i],touch_buf);

				if(dir_flag==1)//
					{
						x[i]=((u16)(touch_buf[0]&0X0F)<<8)+touch_buf[1];
						y[i]=((u16)(touch_buf[2]&0X0F)<<8)+touch_buf[3];						
					}else        //
					{
						x[i]=480-(((u16)(touch_buf[2]&0X0F)<<8)+touch_buf[3]);
						y[i]=((u16)(touch_buf[0]&0X0F)<<8)+touch_buf[1];
					} 
        	Draw_Point(x[i],y[i],Touch_Point_COLOR[i]);		//	
			}		
	}
	else  //̧Ļ  Ҫ̧Чֵ ɲοxpt2046
	{                    //Ҳɸݶ׸Ĵĸλж,οFTֲ
   for(j=0;j<num;j++)
		{
			x[j]=0xffff;
			y[j]=0xffff;
		}
	}	 
}






 



























