

//Ƭͷļ
#include "stm32f4xx.h"                  // Device header


//豸
#include "esp8266.h"

//Эļ
#include "onenet.h"
#include "mqttkit.h"

//Ӳ
#include "usart.h"


//C
#include <string.h>
#include <stdio.h>
#include "cJSON.h"



#define PROID		"huaqing_smarthome"

#define AUTH_INFO	"huaqing_smarthome_zui_jiandan"

#define DEVID		"huaqing_smarthome"


extern unsigned char esp8266_buf[128];
extern u8 alarmFlag;//Ƿ񱨾ı־
extern u8 alarm_is_free;





//==========================================================
//	ƣ	OneNet_DevLink
//
//	ܣ	onenet
//
//	ڲ	
//
//	ز	1-ɹ	0-ʧ
//
//	˵		onenetƽ̨
//==========================================================
_Bool OneNet_DevLink(void)
{
	char ProductID[64];
	char Auth_Info[64];
	char DeviceID[64];
	
	u32 MCU_ID;
	
	MQTT_PACKET_STRUCTURE mqttPacket = {NULL, 0, 0, 0};					//Э

	unsigned char *dataPtr;
	
	_Bool status = 1;
	
	MCU_ID = *(vu32*)(0x1FFFF7E8);	//ȡMCUΨһʶ
	sprintf(ProductID,"%s_%X",PROID,MCU_ID);
	sprintf(Auth_Info,"%s_%X",AUTH_INFO,MCU_ID);
	sprintf(DeviceID,"%s_%X",DEVID,MCU_ID);
	
	
	printf("OneNet_DevLink\r\n"
							"PROID: %s,	AUIF: %s,	DEVID:%s	--- ....\r\n"
                        ,ProductID, Auth_Info, DeviceID);
	
	if(MQTT_PacketConnect(ProductID, Auth_Info, DeviceID, 256, 0, MQTT_QOS_LEVEL0, NULL, NULL, 0, &mqttPacket) == 0)
	{
		ESP8266_SendData(mqttPacket._data, mqttPacket._len);			//ϴƽ̨
		
		dataPtr = ESP8266_GetIPD(250);									//ȴƽ̨Ӧ
		if(dataPtr != NULL)
		{
			if(MQTT_UnPacketRecv(dataPtr) == MQTT_PKT_CONNACK)
			{
				switch(MQTT_UnPacketConnectAck(dataPtr))
				{
					case 0:printf("Tips:	ӳɹ\r\n");status = 0;break;
					
					case 1:printf("WARN:	ʧܣЭ\r\n");break;
					case 2:printf("WARN:	ʧܣǷclientid\r\n");break;
					case 3:printf("WARN:	ʧܣʧ\r\n");break;
					case 4:printf("WARN:	ʧܣû\r\n");break;
					case 5:printf("WARN:	ʧܣǷ(tokenǷ)\r\n");break;
					
					default:printf("ERR:	ʧܣδ֪\r\n");break;
				}
			}
		}
		
		MQTT_DeleteBuffer(&mqttPacket);								//ɾ
	}
	else
		printf("WARN:	MQTT_PacketConnect Failed\r\n");
	
	return status;
	
}

//==========================================================
//	ƣ	OneNet_Subscribe
//
//	ܣ	
//
//	ڲ	topicsĵtopic
//				topic_cnttopic
//
//	ز	SEND_TYPE_OK-ɹ	SEND_TYPE_SUBSCRIBE-Ҫط
//
//	˵		
//==========================================================
void OneNet_Subscribe(const char *topics[], unsigned char topic_cnt)
{
	
	unsigned char i = 0;
	
	MQTT_PACKET_STRUCTURE mqttPacket = {NULL, 0, 0, 0};							//Э
	
	for(; i < topic_cnt; i++)
		printf("Subscribe Topic: %s\r\n", topics[i]);
	
	if(MQTT_PacketSubscribe(MQTT_SUBSCRIBE_ID, MQTT_QOS_LEVEL0, topics, topic_cnt, &mqttPacket) == 0)
	{
		ESP8266_SendData(mqttPacket._data, mqttPacket._len);					//ƽ̨Ͷ
		
		MQTT_DeleteBuffer(&mqttPacket);											//ɾ
	}

}

//==========================================================
//	ƣ	OneNet_Publish
//
//	ܣ	Ϣ
//
//	ڲ	topic
//				msgϢ
//
//	ز	SEND_TYPE_OK-ɹ	SEND_TYPE_PUBLISH-Ҫ
//
//	˵		
//==========================================================
void OneNet_Publish(const char *topic, const char *msg)
{

	MQTT_PACKET_STRUCTURE mqttPacket = {NULL, 0, 0, 0};							//Э
	
	printf("Publish Topic: %s, Msg: %s\r\n", topic, msg);
	
	if(MQTT_PacketPublish(MQTT_PUBLISH_ID, topic, msg, strlen(msg), MQTT_QOS_LEVEL0, 0, 1, &mqttPacket) == 0)
	{
		ESP8266_SendData(mqttPacket._data, mqttPacket._len);					//ƽ̨Ͷ
		
		MQTT_DeleteBuffer(&mqttPacket);											//ɾ
	}

}

//==========================================================
//	ƣ	OneNet_RevPro
//
//	ܣ	ƽ̨ݼ
//
//	ڲ	dataPtrƽ̨ص Ҳ*cmd
//
//	ز	
//
//	˵		
//==========================================================
void OneNet_RevPro(unsigned char *cmd)
{
	
	MQTT_PACKET_STRUCTURE mqttPacket = {NULL, 0, 0, 0};								//Э
	
	char *req_payload = NULL;
	char *cmdid_topic = NULL;
	
	unsigned short topic_len = 0;
	unsigned short req_len = 0;
	
	unsigned char type = 0;
	unsigned char qos = 0;
	static unsigned short pkt_id = 0;
	
	short result = 0;

	char *dataPtr = NULL;
	char numBuf[10];
	int num = 0;
	
	cJSON *json , *json_value;
	
	type = MQTT_UnPacketRecv(cmd);
	switch(type)
	{
		case MQTT_PKT_CMD:															//·
			
			result = MQTT_UnPacketCmd(cmd, &cmdid_topic, &req_payload, &req_len);	//topicϢ
			if(result == 0)
			{
				printf("cmdid: %s, req: %s, req_len: %d\r\n", cmdid_topic, req_payload, req_len);

				MQTT_DeleteBuffer(&mqttPacket);									//ɾ
			}
		break;
			
		case MQTT_PKT_PUBLISH:														//յPublishϢ
		
			result = MQTT_UnPacketPublish(cmd, &cmdid_topic, &topic_len, &req_payload, &req_len, &qos, &pkt_id);
			if(result == 0)
			{
				printf("topic: %s, topic_len: %d, payload: %s, payload_len: %d\r\n",
																	cmdid_topic, topic_len, req_payload, req_len);
				// ݰreq_payloadJSONʽ
				json = cJSON_Parse(req_payload);
				if (!json)printf("Error before: [%s]\n",cJSON_GetErrorPtr());
				else
				{
					json_value = cJSON_GetObjectItem(json , "target");
					printf("json_value: [%s]\n",json_value->string);
					printf("json_value: [%s]\n",json_value->valuestring);
					if(strstr(json_value->valuestring,"gate") != NULL)
					{
						json_value = cJSON_GetObjectItem(json , "value");
						if(json_value->valueint)
						{
							HAL_GPIO_WritePin(GPIOG, GPIO_PIN_14, GPIO_PIN_RESET);
							//
						}
						else
						{							
							HAL_GPIO_WritePin(GPIOG, GPIO_PIN_14, GPIO_PIN_SET);;//ص
						}
					}
					else
					{
						json_value = cJSON_GetObjectItem(json , "value");
						if(json_value->valueint)alarmFlag = 1;//򿪱
						else alarmFlag = 0;//رձ
						alarm_is_free=0;//λƸֶƾһȼ ԶƣҪalarm_is_free 0
					}
//					if(json_value->valueint)//json_value > 0Ϊ
//					{
//						LED0 = 0;//LED0 
//					}
//					else
//					{
//						LED0 = 1;//رLED0 
//					}
				}
				cJSON_Delete(json);
			}
		break;
			
		case MQTT_PKT_PUBACK:														//PublishϢƽ̨ظAck
		
			if(MQTT_UnPacketPublishAck(cmd) == 0)
				printf("Tips:	MQTT Publish Send OK\r\n");
			
		break;
			
		case MQTT_PKT_PUBREC:														//PublishϢƽ̨ظRec豸ظRelϢ
		
			if(MQTT_UnPacketPublishRec(cmd) == 0)
			{
				printf("Tips:	Rev PublishRec\r\n");
				if(MQTT_PacketPublishRel(MQTT_PUBLISH_ID, &mqttPacket) == 0)
				{
					printf("Tips:	Send PublishRel\r\n");
					ESP8266_SendData(mqttPacket._data, mqttPacket._len);
					MQTT_DeleteBuffer(&mqttPacket);
				}
			}
		
		break;
			
		case MQTT_PKT_PUBREL:														//յPublishϢ豸ظRecƽ̨ظRel豸ٻظComp
			
			if(MQTT_UnPacketPublishRel(cmd, pkt_id) == 0)
			{
				printf("Tips:	Rev PublishRel\r\n");
				if(MQTT_PacketPublishComp(MQTT_PUBLISH_ID, &mqttPacket) == 0)
				{
					printf("Tips:	Send PublishComp\r\n");
					ESP8266_SendData(mqttPacket._data, mqttPacket._len);
					MQTT_DeleteBuffer(&mqttPacket);
				}
			}
		
		break;
		
		case MQTT_PKT_PUBCOMP:														//PublishϢƽ̨Rec豸ظRelƽ̨ٷصComp
		
			if(MQTT_UnPacketPublishComp(cmd) == 0)
			{
				printf("Tips:	Rev PublishComp\r\n");
			}
		
		break;
			
		case MQTT_PKT_SUBACK:														//SubscribeϢAck
		
			if(MQTT_UnPacketSubscribe(cmd) == 0)
				printf("Tips:	MQTT Subscribe OK\r\n");
			else
				printf("Tips:	MQTT Subscribe Err\r\n");
		
		break;
			
		case MQTT_PKT_UNSUBACK:														//UnSubscribeϢAck
		
			if(MQTT_UnPacketUnSubscribe(cmd) == 0)
				printf("Tips:	MQTT UnSubscribe OK\r\n");
			else
				printf("Tips:	MQTT UnSubscribe Err\r\n");
		
		break;
		
		default:
			result = -1;
		break;
	}
	
	ESP8266_Clear();									//ջ
	
	if(result == -1)
		return;
	
	dataPtr = strchr(req_payload, '}');					//'}'

	if(dataPtr != NULL && result != -1)					//ҵ
	{
		dataPtr++;
		
		while(*dataPtr >= '0' && *dataPtr <= '9')		//жǷ·
		{
			numBuf[num++] = *dataPtr++;
		}
		
		num = atoi((const char *)numBuf);				//תΪֵʽ
		
	}

	if(type == MQTT_PKT_CMD || type == MQTT_PKT_PUBLISH)
	{
		MQTT_FreeBuffer(cmdid_topic);
		MQTT_FreeBuffer(req_payload);
	}

}
