/*
 * Copyright 2022 NXP
 * SPDX-License-Identifier: MIT
 * The auto-generated can only be used on NXP devices
 */

#include "lvgl.h"
#include <stdio.h>
#include "gui_guider.h"
#include "events_init.h"
#include "custom.h"

static lv_obj_t * screen4_spinbox_3;
static void lv_screen4_spinbox_3_increment_event_cb(lv_event_t * event)
{
	lv_event_code_t code = lv_event_get_code(event);
	if(code == LV_EVENT_SHORT_CLICKED || code == LV_EVENT_LONG_PRESSED_REPEAT){
	lv_spinbox_increment(screen4_spinbox_3);
	}
}
static void lv_screen4_spinbox_3_decrement_event_cb(lv_event_t * event)
{
	lv_event_code_t code = lv_event_get_code(event);
	if(code == LV_EVENT_SHORT_CLICKED || code == LV_EVENT_LONG_PRESSED_REPEAT){
	lv_spinbox_decrement(screen4_spinbox_3);
	}
}

void setup_scr_screen4(lv_ui *ui){

	//Write codes screen4
	ui->screen4 = lv_obj_create(NULL);

	//Write style state: LV_STATE_DEFAULT for style_screen4_main_main_default
	static lv_style_t style_screen4_main_main_default;
	if (style_screen4_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_main_main_default);
	else
		lv_style_init(&style_screen4_main_main_default);
	lv_style_set_bg_color(&style_screen4_main_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_opa(&style_screen4_main_main_default, 0);
	lv_obj_add_style(ui->screen4, &style_screen4_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write codes screen4_imgbtn_2
	ui->screen4_imgbtn_2 = lv_imgbtn_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_imgbtn_2, 4, 6);
	lv_obj_set_size(ui->screen4_imgbtn_2, 32, 27);

	//Write style state: LV_STATE_DEFAULT for style_screen4_imgbtn_2_main_main_default
	static lv_style_t style_screen4_imgbtn_2_main_main_default;
	if (style_screen4_imgbtn_2_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_imgbtn_2_main_main_default);
	else
		lv_style_init(&style_screen4_imgbtn_2_main_main_default);
	lv_style_set_text_color(&style_screen4_imgbtn_2_main_main_default, lv_color_make(0x00, 0x00, 0x00));
	lv_style_set_img_recolor(&style_screen4_imgbtn_2_main_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_img_recolor_opa(&style_screen4_imgbtn_2_main_main_default, 0);
	lv_style_set_img_opa(&style_screen4_imgbtn_2_main_main_default, 255);
	lv_obj_add_style(ui->screen4_imgbtn_2, &style_screen4_imgbtn_2_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write style state: LV_STATE_PRESSED for style_screen4_imgbtn_2_main_main_pressed
	static lv_style_t style_screen4_imgbtn_2_main_main_pressed;
	if (style_screen4_imgbtn_2_main_main_pressed.prop_cnt > 1)
		lv_style_reset(&style_screen4_imgbtn_2_main_main_pressed);
	else
		lv_style_init(&style_screen4_imgbtn_2_main_main_pressed);
	lv_style_set_text_color(&style_screen4_imgbtn_2_main_main_pressed, lv_color_make(0xFF, 0x33, 0xFF));
	lv_style_set_img_recolor(&style_screen4_imgbtn_2_main_main_pressed, lv_color_make(0x00, 0x00, 0x00));
	lv_style_set_img_recolor_opa(&style_screen4_imgbtn_2_main_main_pressed, 0);
	lv_obj_add_style(ui->screen4_imgbtn_2, &style_screen4_imgbtn_2_main_main_pressed, LV_PART_MAIN|LV_STATE_PRESSED);

	//Write style state: LV_STATE_CHECKED for style_screen4_imgbtn_2_main_main_checked
	static lv_style_t style_screen4_imgbtn_2_main_main_checked;
	if (style_screen4_imgbtn_2_main_main_checked.prop_cnt > 1)
		lv_style_reset(&style_screen4_imgbtn_2_main_main_checked);
	else
		lv_style_init(&style_screen4_imgbtn_2_main_main_checked);
	lv_style_set_text_color(&style_screen4_imgbtn_2_main_main_checked, lv_color_make(0xFF, 0x33, 0xFF));
	lv_style_set_img_recolor(&style_screen4_imgbtn_2_main_main_checked, lv_color_make(0x00, 0x00, 0x00));
	lv_style_set_img_recolor_opa(&style_screen4_imgbtn_2_main_main_checked, 0);
	lv_obj_add_style(ui->screen4_imgbtn_2, &style_screen4_imgbtn_2_main_main_checked, LV_PART_MAIN|LV_STATE_CHECKED);
	lv_imgbtn_set_src(ui->screen4_imgbtn_2, LV_IMGBTN_STATE_RELEASED, NULL, &_return_alpha_32x27, NULL);
	lv_imgbtn_set_src(ui->screen4_imgbtn_2, LV_IMGBTN_STATE_PRESSED, NULL, &_set_blue_alpha_32x27, NULL);
	lv_imgbtn_set_src(ui->screen4_imgbtn_2, LV_IMGBTN_STATE_CHECKED_RELEASED, NULL, &_return_alpha_32x27, NULL);
	lv_imgbtn_set_src(ui->screen4_imgbtn_2, LV_IMGBTN_STATE_CHECKED_PRESSED, NULL, &_set_blue_alpha_32x27, NULL);
	lv_obj_add_flag(ui->screen4_imgbtn_2, LV_OBJ_FLAG_CHECKABLE);

	//Write codes screen4_label_9
	ui->screen4_label_9 = lv_label_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_label_9, 29, 64);
	lv_obj_set_size(ui->screen4_label_9, 120, 31);
	lv_label_set_text(ui->screen4_label_9, "风扇");
	lv_label_set_long_mode(ui->screen4_label_9, LV_LABEL_LONG_WRAP);
	lv_obj_set_style_text_align(ui->screen4_label_9, LV_TEXT_ALIGN_CENTER, 0);

	//Write style state: LV_STATE_DEFAULT for style_screen4_label_9_main_main_default
	static lv_style_t style_screen4_label_9_main_main_default;
	if (style_screen4_label_9_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_label_9_main_main_default);
	else
		lv_style_init(&style_screen4_label_9_main_main_default);
	lv_style_set_radius(&style_screen4_label_9_main_main_default, 10);
	lv_style_set_bg_color(&style_screen4_label_9_main_main_default, lv_color_make(0xf0, 0xf0, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_label_9_main_main_default, lv_color_make(0xf1, 0xf0, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_label_9_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_label_9_main_main_default, 255);
	lv_style_set_text_color(&style_screen4_label_9_main_main_default, lv_color_make(0x00, 0x00, 0x00));
	lv_style_set_text_font(&style_screen4_label_9_main_main_default, &lv_font_simsun_12);
	lv_style_set_text_letter_space(&style_screen4_label_9_main_main_default, 2);
	lv_style_set_pad_left(&style_screen4_label_9_main_main_default, 0);
	lv_style_set_pad_right(&style_screen4_label_9_main_main_default, 0);
	lv_style_set_pad_top(&style_screen4_label_9_main_main_default, 0);
	lv_style_set_pad_bottom(&style_screen4_label_9_main_main_default, 0);
	lv_obj_add_style(ui->screen4_label_9, &style_screen4_label_9_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write codes screen4_label_10
	ui->screen4_label_10 = lv_label_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_label_10, 170, 64);
	lv_obj_set_size(ui->screen4_label_10, 120, 31);
	lv_label_set_text(ui->screen4_label_10, "消毒");
	lv_label_set_long_mode(ui->screen4_label_10, LV_LABEL_LONG_WRAP);
	lv_obj_set_style_text_align(ui->screen4_label_10, LV_TEXT_ALIGN_CENTER, 0);

	//Write style state: LV_STATE_DEFAULT for style_screen4_label_10_main_main_default
	static lv_style_t style_screen4_label_10_main_main_default;
	if (style_screen4_label_10_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_label_10_main_main_default);
	else
		lv_style_init(&style_screen4_label_10_main_main_default);
	lv_style_set_radius(&style_screen4_label_10_main_main_default, 10);
	lv_style_set_bg_color(&style_screen4_label_10_main_main_default, lv_color_make(0xf0, 0xf0, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_label_10_main_main_default, lv_color_make(0xf1, 0xf0, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_label_10_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_label_10_main_main_default, 255);
	lv_style_set_text_color(&style_screen4_label_10_main_main_default, lv_color_make(0x00, 0x00, 0x00));
	lv_style_set_text_font(&style_screen4_label_10_main_main_default, &lv_font_simsun_12);
	lv_style_set_text_letter_space(&style_screen4_label_10_main_main_default, 2);
	lv_style_set_pad_left(&style_screen4_label_10_main_main_default, 0);
	lv_style_set_pad_right(&style_screen4_label_10_main_main_default, 0);
	lv_style_set_pad_top(&style_screen4_label_10_main_main_default, 0);
	lv_style_set_pad_bottom(&style_screen4_label_10_main_main_default, 0);
	lv_obj_add_style(ui->screen4_label_10, &style_screen4_label_10_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write codes screen4_label_11
	ui->screen4_label_11 = lv_label_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_label_11, 29, 121);
	lv_obj_set_size(ui->screen4_label_11, 120, 31);
	lv_label_set_text(ui->screen4_label_11, "箱门");
	lv_label_set_long_mode(ui->screen4_label_11, LV_LABEL_LONG_WRAP);
	lv_obj_set_style_text_align(ui->screen4_label_11, LV_TEXT_ALIGN_CENTER, 0);

	//Write style state: LV_STATE_DEFAULT for style_screen4_label_11_main_main_default
	static lv_style_t style_screen4_label_11_main_main_default;
	if (style_screen4_label_11_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_label_11_main_main_default);
	else
		lv_style_init(&style_screen4_label_11_main_main_default);
	lv_style_set_radius(&style_screen4_label_11_main_main_default, 10);
	lv_style_set_bg_color(&style_screen4_label_11_main_main_default, lv_color_make(0xf0, 0xf0, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_label_11_main_main_default, lv_color_make(0xf1, 0xf0, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_label_11_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_label_11_main_main_default, 255);
	lv_style_set_text_color(&style_screen4_label_11_main_main_default, lv_color_make(0x00, 0x00, 0x00));
	lv_style_set_text_font(&style_screen4_label_11_main_main_default, &lv_font_simsun_12);
	lv_style_set_text_letter_space(&style_screen4_label_11_main_main_default, 2);
	lv_style_set_pad_left(&style_screen4_label_11_main_main_default, 0);
	lv_style_set_pad_right(&style_screen4_label_11_main_main_default, 0);
	lv_style_set_pad_top(&style_screen4_label_11_main_main_default, 0);
	lv_style_set_pad_bottom(&style_screen4_label_11_main_main_default, 0);
	lv_obj_add_style(ui->screen4_label_11, &style_screen4_label_11_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write codes screen4_label_12
	ui->screen4_label_12 = lv_label_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_label_12, 170, 119);
	lv_obj_set_size(ui->screen4_label_12, 120, 31);
	lv_label_set_text(ui->screen4_label_12, "警报");
	lv_label_set_long_mode(ui->screen4_label_12, LV_LABEL_LONG_WRAP);
	lv_obj_set_style_text_align(ui->screen4_label_12, LV_TEXT_ALIGN_CENTER, 0);

	//Write style state: LV_STATE_DEFAULT for style_screen4_label_12_main_main_default
	static lv_style_t style_screen4_label_12_main_main_default;
	if (style_screen4_label_12_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_label_12_main_main_default);
	else
		lv_style_init(&style_screen4_label_12_main_main_default);
	lv_style_set_radius(&style_screen4_label_12_main_main_default, 10);
	lv_style_set_bg_color(&style_screen4_label_12_main_main_default, lv_color_make(0xf0, 0xf0, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_label_12_main_main_default, lv_color_make(0xf1, 0xf0, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_label_12_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_label_12_main_main_default, 255);
	lv_style_set_text_color(&style_screen4_label_12_main_main_default, lv_color_make(0x00, 0x00, 0x00));
	lv_style_set_text_font(&style_screen4_label_12_main_main_default, &lv_font_simsun_12);
	lv_style_set_text_letter_space(&style_screen4_label_12_main_main_default, 2);
	lv_style_set_pad_left(&style_screen4_label_12_main_main_default, 0);
	lv_style_set_pad_right(&style_screen4_label_12_main_main_default, 0);
	lv_style_set_pad_top(&style_screen4_label_12_main_main_default, 0);
	lv_style_set_pad_bottom(&style_screen4_label_12_main_main_default, 0);
	lv_obj_add_style(ui->screen4_label_12, &style_screen4_label_12_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write codes screen4_sw_1
	ui->screen4_sw_1 = lv_switch_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_sw_1, 71, 77);
	lv_obj_set_size(ui->screen4_sw_1, 35, 18);

	//Write style state: LV_STATE_DEFAULT for style_screen4_sw_1_main_main_default
	static lv_style_t style_screen4_sw_1_main_main_default;
	if (style_screen4_sw_1_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_1_main_main_default);
	else
		lv_style_init(&style_screen4_sw_1_main_main_default);
	lv_style_set_radius(&style_screen4_sw_1_main_main_default, 100);
	lv_style_set_bg_color(&style_screen4_sw_1_main_main_default, lv_color_make(0xe6, 0xe2, 0xe6));
	lv_style_set_bg_grad_color(&style_screen4_sw_1_main_main_default, lv_color_make(0xe6, 0xe2, 0xe6));
	lv_style_set_bg_grad_dir(&style_screen4_sw_1_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_1_main_main_default, 255);
	lv_obj_add_style(ui->screen4_sw_1, &style_screen4_sw_1_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write style state: LV_STATE_CHECKED for style_screen4_sw_1_main_indicator_checked
	static lv_style_t style_screen4_sw_1_main_indicator_checked;
	if (style_screen4_sw_1_main_indicator_checked.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_1_main_indicator_checked);
	else
		lv_style_init(&style_screen4_sw_1_main_indicator_checked);
	lv_style_set_radius(&style_screen4_sw_1_main_indicator_checked, 100);
	lv_style_set_bg_color(&style_screen4_sw_1_main_indicator_checked, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_color(&style_screen4_sw_1_main_indicator_checked, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_dir(&style_screen4_sw_1_main_indicator_checked, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_1_main_indicator_checked, 255);
	lv_obj_add_style(ui->screen4_sw_1, &style_screen4_sw_1_main_indicator_checked, LV_PART_INDICATOR|LV_STATE_CHECKED);

	//Write style state: LV_STATE_DEFAULT for style_screen4_sw_1_main_knob_default
	static lv_style_t style_screen4_sw_1_main_knob_default;
	if (style_screen4_sw_1_main_knob_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_1_main_knob_default);
	else
		lv_style_init(&style_screen4_sw_1_main_knob_default);
	lv_style_set_radius(&style_screen4_sw_1_main_knob_default, 100);
	lv_style_set_bg_color(&style_screen4_sw_1_main_knob_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_sw_1_main_knob_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_sw_1_main_knob_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_1_main_knob_default, 255);
	lv_obj_add_style(ui->screen4_sw_1, &style_screen4_sw_1_main_knob_default, LV_PART_KNOB|LV_STATE_DEFAULT);

	//Write codes screen4_sw_2
	ui->screen4_sw_2 = lv_switch_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_sw_2, 208, 77);
	lv_obj_set_size(ui->screen4_sw_2, 35, 18);

	//Write style state: LV_STATE_DEFAULT for style_screen4_sw_2_main_main_default
	static lv_style_t style_screen4_sw_2_main_main_default;
	if (style_screen4_sw_2_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_2_main_main_default);
	else
		lv_style_init(&style_screen4_sw_2_main_main_default);
	lv_style_set_radius(&style_screen4_sw_2_main_main_default, 100);
	lv_style_set_bg_color(&style_screen4_sw_2_main_main_default, lv_color_make(0xe6, 0xe2, 0xe6));
	lv_style_set_bg_grad_color(&style_screen4_sw_2_main_main_default, lv_color_make(0xe6, 0xe2, 0xe6));
	lv_style_set_bg_grad_dir(&style_screen4_sw_2_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_2_main_main_default, 255);
	lv_obj_add_style(ui->screen4_sw_2, &style_screen4_sw_2_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write style state: LV_STATE_CHECKED for style_screen4_sw_2_main_indicator_checked
	static lv_style_t style_screen4_sw_2_main_indicator_checked;
	if (style_screen4_sw_2_main_indicator_checked.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_2_main_indicator_checked);
	else
		lv_style_init(&style_screen4_sw_2_main_indicator_checked);
	lv_style_set_radius(&style_screen4_sw_2_main_indicator_checked, 100);
	lv_style_set_bg_color(&style_screen4_sw_2_main_indicator_checked, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_color(&style_screen4_sw_2_main_indicator_checked, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_dir(&style_screen4_sw_2_main_indicator_checked, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_2_main_indicator_checked, 255);
	lv_obj_add_style(ui->screen4_sw_2, &style_screen4_sw_2_main_indicator_checked, LV_PART_INDICATOR|LV_STATE_CHECKED);

	//Write style state: LV_STATE_DEFAULT for style_screen4_sw_2_main_knob_default
	static lv_style_t style_screen4_sw_2_main_knob_default;
	if (style_screen4_sw_2_main_knob_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_2_main_knob_default);
	else
		lv_style_init(&style_screen4_sw_2_main_knob_default);
	lv_style_set_radius(&style_screen4_sw_2_main_knob_default, 100);
	lv_style_set_bg_color(&style_screen4_sw_2_main_knob_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_sw_2_main_knob_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_sw_2_main_knob_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_2_main_knob_default, 255);
	lv_obj_add_style(ui->screen4_sw_2, &style_screen4_sw_2_main_knob_default, LV_PART_KNOB|LV_STATE_DEFAULT);

	//Write codes screen4_sw_3
	ui->screen4_sw_3 = lv_switch_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_sw_3, 213, 132);
	lv_obj_set_size(ui->screen4_sw_3, 35, 18);

	//Write style state: LV_STATE_DEFAULT for style_screen4_sw_3_main_main_default
	static lv_style_t style_screen4_sw_3_main_main_default;
	if (style_screen4_sw_3_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_3_main_main_default);
	else
		lv_style_init(&style_screen4_sw_3_main_main_default);
	lv_style_set_radius(&style_screen4_sw_3_main_main_default, 100);
	lv_style_set_bg_color(&style_screen4_sw_3_main_main_default, lv_color_make(0xe6, 0xe2, 0xe6));
	lv_style_set_bg_grad_color(&style_screen4_sw_3_main_main_default, lv_color_make(0xe6, 0xe2, 0xe6));
	lv_style_set_bg_grad_dir(&style_screen4_sw_3_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_3_main_main_default, 255);
	lv_obj_add_style(ui->screen4_sw_3, &style_screen4_sw_3_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write style state: LV_STATE_CHECKED for style_screen4_sw_3_main_indicator_checked
	static lv_style_t style_screen4_sw_3_main_indicator_checked;
	if (style_screen4_sw_3_main_indicator_checked.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_3_main_indicator_checked);
	else
		lv_style_init(&style_screen4_sw_3_main_indicator_checked);
	lv_style_set_radius(&style_screen4_sw_3_main_indicator_checked, 100);
	lv_style_set_bg_color(&style_screen4_sw_3_main_indicator_checked, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_color(&style_screen4_sw_3_main_indicator_checked, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_dir(&style_screen4_sw_3_main_indicator_checked, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_3_main_indicator_checked, 255);
	lv_obj_add_style(ui->screen4_sw_3, &style_screen4_sw_3_main_indicator_checked, LV_PART_INDICATOR|LV_STATE_CHECKED);

	//Write style state: LV_STATE_DEFAULT for style_screen4_sw_3_main_knob_default
	static lv_style_t style_screen4_sw_3_main_knob_default;
	if (style_screen4_sw_3_main_knob_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_3_main_knob_default);
	else
		lv_style_init(&style_screen4_sw_3_main_knob_default);
	lv_style_set_radius(&style_screen4_sw_3_main_knob_default, 100);
	lv_style_set_bg_color(&style_screen4_sw_3_main_knob_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_sw_3_main_knob_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_sw_3_main_knob_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_3_main_knob_default, 255);
	lv_obj_add_style(ui->screen4_sw_3, &style_screen4_sw_3_main_knob_default, LV_PART_KNOB|LV_STATE_DEFAULT);

	//Write codes screen4_label_14
	ui->screen4_label_14 = lv_label_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_label_14, 99, 15);
	lv_obj_set_size(ui->screen4_label_14, 120, 31);
	lv_label_set_text(ui->screen4_label_14, "设备控制");
	lv_label_set_long_mode(ui->screen4_label_14, LV_LABEL_LONG_WRAP);
	lv_obj_set_style_text_align(ui->screen4_label_14, LV_TEXT_ALIGN_CENTER, 0);

	//Write style state: LV_STATE_DEFAULT for style_screen4_label_14_main_main_default
	static lv_style_t style_screen4_label_14_main_main_default;
	if (style_screen4_label_14_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_label_14_main_main_default);
	else
		lv_style_init(&style_screen4_label_14_main_main_default);
	lv_style_set_radius(&style_screen4_label_14_main_main_default, 10);
	lv_style_set_bg_color(&style_screen4_label_14_main_main_default, lv_color_make(0xf0, 0xf0, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_label_14_main_main_default, lv_color_make(0xf1, 0xf0, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_label_14_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_label_14_main_main_default, 255);
	lv_style_set_text_color(&style_screen4_label_14_main_main_default, lv_color_make(0x00, 0x00, 0x00));
	lv_style_set_text_font(&style_screen4_label_14_main_main_default, &lv_font_simsun_12);
	lv_style_set_text_letter_space(&style_screen4_label_14_main_main_default, 2);
	lv_style_set_pad_left(&style_screen4_label_14_main_main_default, 0);
	lv_style_set_pad_right(&style_screen4_label_14_main_main_default, 0);
	lv_style_set_pad_top(&style_screen4_label_14_main_main_default, 0);
	lv_style_set_pad_bottom(&style_screen4_label_14_main_main_default, 0);
	lv_obj_add_style(ui->screen4_label_14, &style_screen4_label_14_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write codes screen4_img_1
	ui->screen4_img_1 = lv_img_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_img_1, 37, 66);
	lv_obj_set_size(ui->screen4_img_1, 24, 24);

	//Write style state: LV_STATE_DEFAULT for style_screen4_img_1_main_main_default
	static lv_style_t style_screen4_img_1_main_main_default;
	if (style_screen4_img_1_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_img_1_main_main_default);
	else
		lv_style_init(&style_screen4_img_1_main_main_default);
	lv_style_set_img_recolor(&style_screen4_img_1_main_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_img_recolor_opa(&style_screen4_img_1_main_main_default, 0);
	lv_style_set_img_opa(&style_screen4_img_1_main_main_default, 255);
	lv_obj_add_style(ui->screen4_img_1, &style_screen4_img_1_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);
	lv_obj_add_flag(ui->screen4_img_1, LV_OBJ_FLAG_CLICKABLE);
	lv_img_set_src(ui->screen4_img_1,&_feng_24x24);
	lv_img_set_pivot(ui->screen4_img_1, 0,0);
	lv_img_set_angle(ui->screen4_img_1, 0);

	//Write codes screen4_img_2
	ui->screen4_img_2 = lv_img_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_img_2, 177, 68);
	lv_obj_set_size(ui->screen4_img_2, 24, 24);

	//Write style state: LV_STATE_DEFAULT for style_screen4_img_2_main_main_default
	static lv_style_t style_screen4_img_2_main_main_default;
	if (style_screen4_img_2_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_img_2_main_main_default);
	else
		lv_style_init(&style_screen4_img_2_main_main_default);
	lv_style_set_img_recolor(&style_screen4_img_2_main_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_img_recolor_opa(&style_screen4_img_2_main_main_default, 0);
	lv_style_set_img_opa(&style_screen4_img_2_main_main_default, 255);
	lv_obj_add_style(ui->screen4_img_2, &style_screen4_img_2_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);
	lv_obj_add_flag(ui->screen4_img_2, LV_OBJ_FLAG_CLICKABLE);
	lv_img_set_src(ui->screen4_img_2,&_xiao_24x24);
	lv_img_set_pivot(ui->screen4_img_2, 0,0);
	lv_img_set_angle(ui->screen4_img_2, 0);

	//Write codes screen4_img_3
	ui->screen4_img_3 = lv_img_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_img_3, 37, 128);
	lv_obj_set_size(ui->screen4_img_3, 24, 24);

	//Write style state: LV_STATE_DEFAULT for style_screen4_img_3_main_main_default
	static lv_style_t style_screen4_img_3_main_main_default;
	if (style_screen4_img_3_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_img_3_main_main_default);
	else
		lv_style_init(&style_screen4_img_3_main_main_default);
	lv_style_set_img_recolor(&style_screen4_img_3_main_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_img_recolor_opa(&style_screen4_img_3_main_main_default, 0);
	lv_style_set_img_opa(&style_screen4_img_3_main_main_default, 255);
	lv_obj_add_style(ui->screen4_img_3, &style_screen4_img_3_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);
	lv_obj_add_flag(ui->screen4_img_3, LV_OBJ_FLAG_CLICKABLE);
	lv_img_set_src(ui->screen4_img_3,&_ght_24x24);
	lv_img_set_pivot(ui->screen4_img_3, 0,0);
	lv_img_set_angle(ui->screen4_img_3, 0);

	//Write codes screen4_img_4
	ui->screen4_img_4 = lv_img_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_img_4, 177, 124);
	lv_obj_set_size(ui->screen4_img_4, 24, 24);

	//Write style state: LV_STATE_DEFAULT for style_screen4_img_4_main_main_default
	static lv_style_t style_screen4_img_4_main_main_default;
	if (style_screen4_img_4_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_img_4_main_main_default);
	else
		lv_style_init(&style_screen4_img_4_main_main_default);
	lv_style_set_img_recolor(&style_screen4_img_4_main_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_img_recolor_opa(&style_screen4_img_4_main_main_default, 0);
	lv_style_set_img_opa(&style_screen4_img_4_main_main_default, 255);
	lv_obj_add_style(ui->screen4_img_4, &style_screen4_img_4_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);
	lv_obj_add_flag(ui->screen4_img_4, LV_OBJ_FLAG_CLICKABLE);
	lv_img_set_src(ui->screen4_img_4,&_beep_24x24);
	lv_img_set_pivot(ui->screen4_img_4, 0,0);
	lv_img_set_angle(ui->screen4_img_4, 0);

	//Write codes screen4_img_5
	ui->screen4_img_5 = lv_img_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_img_5, 104, 21);
	lv_obj_set_size(ui->screen4_img_5, 24, 24);

	//Write style state: LV_STATE_DEFAULT for style_screen4_img_5_main_main_default
	static lv_style_t style_screen4_img_5_main_main_default;
	if (style_screen4_img_5_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_img_5_main_main_default);
	else
		lv_style_init(&style_screen4_img_5_main_main_default);
	lv_style_set_img_recolor(&style_screen4_img_5_main_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_img_recolor_opa(&style_screen4_img_5_main_main_default, 0);
	lv_style_set_img_opa(&style_screen4_img_5_main_main_default, 255);
	lv_obj_add_style(ui->screen4_img_5, &style_screen4_img_5_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);
	lv_obj_add_flag(ui->screen4_img_5, LV_OBJ_FLAG_CLICKABLE);
	lv_img_set_src(ui->screen4_img_5,&_set_flo_24x24);
	lv_img_set_pivot(ui->screen4_img_5, 0,0);
	lv_img_set_angle(ui->screen4_img_5, 0);

	//Write codes screen4_label_15
	ui->screen4_label_15 = lv_label_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_label_15, 28, 175);
	lv_obj_set_size(ui->screen4_label_15, 120, 31);
	lv_label_set_text(ui->screen4_label_15, "短信测试");
	lv_label_set_long_mode(ui->screen4_label_15, LV_LABEL_LONG_WRAP);
	lv_obj_set_style_text_align(ui->screen4_label_15, LV_TEXT_ALIGN_CENTER, 0);

	//Write style state: LV_STATE_DEFAULT for style_screen4_label_15_main_main_default
	static lv_style_t style_screen4_label_15_main_main_default;
	if (style_screen4_label_15_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_label_15_main_main_default);
	else
		lv_style_init(&style_screen4_label_15_main_main_default);
	lv_style_set_radius(&style_screen4_label_15_main_main_default, 10);
	lv_style_set_bg_color(&style_screen4_label_15_main_main_default, lv_color_make(0xf0, 0xf0, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_label_15_main_main_default, lv_color_make(0xf1, 0xf0, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_label_15_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_label_15_main_main_default, 255);
	lv_style_set_text_color(&style_screen4_label_15_main_main_default, lv_color_make(0x00, 0x00, 0x00));
	lv_style_set_text_font(&style_screen4_label_15_main_main_default, &lv_font_simsun_12);
	lv_style_set_text_letter_space(&style_screen4_label_15_main_main_default, 2);
	lv_style_set_pad_left(&style_screen4_label_15_main_main_default, 0);
	lv_style_set_pad_right(&style_screen4_label_15_main_main_default, 0);
	lv_style_set_pad_top(&style_screen4_label_15_main_main_default, 0);
	lv_style_set_pad_bottom(&style_screen4_label_15_main_main_default, 0);
	lv_obj_add_style(ui->screen4_label_15, &style_screen4_label_15_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write codes screen4_img_6
	ui->screen4_img_6 = lv_img_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_img_6, 37, 177);
	lv_obj_set_size(ui->screen4_img_6, 24, 24);

	//Write style state: LV_STATE_DEFAULT for style_screen4_img_6_main_main_default
	static lv_style_t style_screen4_img_6_main_main_default;
	if (style_screen4_img_6_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_img_6_main_main_default);
	else
		lv_style_init(&style_screen4_img_6_main_main_default);
	lv_style_set_img_recolor(&style_screen4_img_6_main_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_img_recolor_opa(&style_screen4_img_6_main_main_default, 0);
	lv_style_set_img_opa(&style_screen4_img_6_main_main_default, 255);
	lv_obj_add_style(ui->screen4_img_6, &style_screen4_img_6_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);
	lv_obj_add_flag(ui->screen4_img_6, LV_OBJ_FLAG_CLICKABLE);
	lv_img_set_src(ui->screen4_img_6,&_dfd_24x24);
	lv_img_set_pivot(ui->screen4_img_6, 0,0);
	lv_img_set_angle(ui->screen4_img_6, 0);

	//Write codes screen4_spinbox_3
	ui->screen4_spinbox_3 = lv_spinbox_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_spinbox_3, 199, 176);

	//Write style state: LV_STATE_DEFAULT for style_screen4_spinbox_3_main_main_default
	static lv_style_t style_screen4_spinbox_3_main_main_default;
	if (style_screen4_spinbox_3_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_spinbox_3_main_main_default);
	else
		lv_style_init(&style_screen4_spinbox_3_main_main_default);
	lv_style_set_radius(&style_screen4_spinbox_3_main_main_default, 5);
	lv_style_set_bg_color(&style_screen4_spinbox_3_main_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_spinbox_3_main_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_spinbox_3_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_spinbox_3_main_main_default, 255);
	lv_style_set_border_color(&style_screen4_spinbox_3_main_main_default, lv_color_make(0xf0, 0xf1, 0xff));
	lv_style_set_border_width(&style_screen4_spinbox_3_main_main_default, 2);
	lv_style_set_text_color(&style_screen4_spinbox_3_main_main_default, lv_color_make(0x00, 0x00, 0x00));
	lv_style_set_text_font(&style_screen4_spinbox_3_main_main_default, &lv_font_simsun_12);
	lv_style_set_text_letter_space(&style_screen4_spinbox_3_main_main_default, 0);
	lv_style_set_pad_left(&style_screen4_spinbox_3_main_main_default, 2);
	lv_style_set_pad_right(&style_screen4_spinbox_3_main_main_default, 0);
	lv_style_set_pad_top(&style_screen4_spinbox_3_main_main_default, 14);
	lv_style_set_pad_bottom(&style_screen4_spinbox_3_main_main_default, 14);
	lv_obj_add_style(ui->screen4_spinbox_3, &style_screen4_spinbox_3_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write style state: LV_STATE_DEFAULT for style_screen4_spinbox_3_main_cursor_default
	static lv_style_t style_screen4_spinbox_3_main_cursor_default;
	if (style_screen4_spinbox_3_main_cursor_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_spinbox_3_main_cursor_default);
	else
		lv_style_init(&style_screen4_spinbox_3_main_cursor_default);
	lv_style_set_bg_color(&style_screen4_spinbox_3_main_cursor_default, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_color(&style_screen4_spinbox_3_main_cursor_default, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_dir(&style_screen4_spinbox_3_main_cursor_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_spinbox_3_main_cursor_default, 255);
	lv_style_set_text_color(&style_screen4_spinbox_3_main_cursor_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_text_font(&style_screen4_spinbox_3_main_cursor_default, &lv_font_simsun_12);
	lv_obj_add_style(ui->screen4_spinbox_3, &style_screen4_spinbox_3_main_cursor_default, LV_PART_CURSOR|LV_STATE_DEFAULT);

	//Write style state: LV_STATE_DEFAULT for style_screen4_spinbox_3_extra_btns_main_default
	static lv_style_t style_screen4_spinbox_3_extra_btns_main_default;
	if (style_screen4_spinbox_3_extra_btns_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_spinbox_3_extra_btns_main_default);
	else
		lv_style_init(&style_screen4_spinbox_3_extra_btns_main_default);
	lv_style_set_radius(&style_screen4_spinbox_3_extra_btns_main_default, 5);
	lv_style_set_bg_color(&style_screen4_spinbox_3_extra_btns_main_default, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_color(&style_screen4_spinbox_3_extra_btns_main_default, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_dir(&style_screen4_spinbox_3_extra_btns_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_spinbox_3_extra_btns_main_default, 255);
	lv_style_set_border_color(&style_screen4_spinbox_3_extra_btns_main_default, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_border_width(&style_screen4_spinbox_3_extra_btns_main_default, 0);
	lv_style_set_text_color(&style_screen4_spinbox_3_extra_btns_main_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_text_font(&style_screen4_spinbox_3_extra_btns_main_default, &lv_font_simsun_12);
	lv_obj_set_width(ui->screen4_spinbox_3, 73);
	lv_obj_set_height(ui->screen4_spinbox_3, 29);
	lv_spinbox_set_digit_format(ui->screen4_spinbox_3, 4, 2);
	lv_spinbox_step_prev(ui->screen4_spinbox_3);
	lv_spinbox_set_range(ui->screen4_spinbox_3, -99999, 99999);
	lv_spinbox_set_value(ui->screen4_spinbox_3,3733);
	screen4_spinbox_3 = ui->screen4_spinbox_3;
	lv_coord_t screen4_spinbox_3_h = lv_obj_get_height(ui->screen4_spinbox_3);
	ui->screen4_spinbox_3_btn = lv_btn_create(ui->screen4);
	lv_obj_set_size(ui->screen4_spinbox_3_btn, screen4_spinbox_3_h, screen4_spinbox_3_h);
	lv_obj_align_to(ui->screen4_spinbox_3_btn, ui->screen4_spinbox_3, LV_ALIGN_OUT_RIGHT_MID, 5, 0);
	lv_obj_set_style_bg_img_src(ui->screen4_spinbox_3_btn, LV_SYMBOL_PLUS, 0);
	lv_obj_add_event_cb(ui->screen4_spinbox_3_btn, lv_screen4_spinbox_3_increment_event_cb, LV_EVENT_ALL, NULL);
	ui->screen4_spinbox_3_btn_minus = lv_btn_create(ui->screen4);
	lv_obj_set_size(ui->screen4_spinbox_3_btn_minus, screen4_spinbox_3_h, screen4_spinbox_3_h);
	lv_obj_align_to(ui->screen4_spinbox_3_btn_minus, ui->screen4_spinbox_3, LV_ALIGN_OUT_LEFT_MID, -5, 0);
	lv_obj_set_style_bg_img_src(ui->screen4_spinbox_3_btn_minus, LV_SYMBOL_MINUS, 0);
	lv_obj_add_event_cb(ui->screen4_spinbox_3_btn_minus, lv_screen4_spinbox_3_decrement_event_cb, LV_EVENT_ALL, NULL);
	lv_obj_add_style(ui->screen4_spinbox_3_btn, &style_screen4_spinbox_3_extra_btns_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);
	lv_obj_add_style(ui->screen4_spinbox_3_btn_minus, &style_screen4_spinbox_3_extra_btns_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write codes screen4_sw_4
	ui->screen4_sw_4 = lv_switch_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_sw_4, 71, 135);
	lv_obj_set_size(ui->screen4_sw_4, 35, 18);

	//Write style state: LV_STATE_DEFAULT for style_screen4_sw_4_main_main_default
	static lv_style_t style_screen4_sw_4_main_main_default;
	if (style_screen4_sw_4_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_4_main_main_default);
	else
		lv_style_init(&style_screen4_sw_4_main_main_default);
	lv_style_set_radius(&style_screen4_sw_4_main_main_default, 100);
	lv_style_set_bg_color(&style_screen4_sw_4_main_main_default, lv_color_make(0xe6, 0xe2, 0xe6));
	lv_style_set_bg_grad_color(&style_screen4_sw_4_main_main_default, lv_color_make(0xe6, 0xe2, 0xe6));
	lv_style_set_bg_grad_dir(&style_screen4_sw_4_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_4_main_main_default, 255);
	lv_obj_add_style(ui->screen4_sw_4, &style_screen4_sw_4_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write style state: LV_STATE_CHECKED for style_screen4_sw_4_main_indicator_checked
	static lv_style_t style_screen4_sw_4_main_indicator_checked;
	if (style_screen4_sw_4_main_indicator_checked.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_4_main_indicator_checked);
	else
		lv_style_init(&style_screen4_sw_4_main_indicator_checked);
	lv_style_set_radius(&style_screen4_sw_4_main_indicator_checked, 100);
	lv_style_set_bg_color(&style_screen4_sw_4_main_indicator_checked, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_color(&style_screen4_sw_4_main_indicator_checked, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_dir(&style_screen4_sw_4_main_indicator_checked, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_4_main_indicator_checked, 255);
	lv_obj_add_style(ui->screen4_sw_4, &style_screen4_sw_4_main_indicator_checked, LV_PART_INDICATOR|LV_STATE_CHECKED);

	//Write style state: LV_STATE_DEFAULT for style_screen4_sw_4_main_knob_default
	static lv_style_t style_screen4_sw_4_main_knob_default;
	if (style_screen4_sw_4_main_knob_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_4_main_knob_default);
	else
		lv_style_init(&style_screen4_sw_4_main_knob_default);
	lv_style_set_radius(&style_screen4_sw_4_main_knob_default, 100);
	lv_style_set_bg_color(&style_screen4_sw_4_main_knob_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_sw_4_main_knob_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_sw_4_main_knob_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_4_main_knob_default, 255);
	lv_obj_add_style(ui->screen4_sw_4, &style_screen4_sw_4_main_knob_default, LV_PART_KNOB|LV_STATE_DEFAULT);

	//Write codes screen4_sw_5
	ui->screen4_sw_5 = lv_switch_create(ui->screen4);
	lv_obj_set_pos(ui->screen4_sw_5, 71, 187);
	lv_obj_set_size(ui->screen4_sw_5, 35, 18);

	//Write style state: LV_STATE_DEFAULT for style_screen4_sw_5_main_main_default
	static lv_style_t style_screen4_sw_5_main_main_default;
	if (style_screen4_sw_5_main_main_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_5_main_main_default);
	else
		lv_style_init(&style_screen4_sw_5_main_main_default);
	lv_style_set_radius(&style_screen4_sw_5_main_main_default, 100);
	lv_style_set_bg_color(&style_screen4_sw_5_main_main_default, lv_color_make(0xe6, 0xe2, 0xe6));
	lv_style_set_bg_grad_color(&style_screen4_sw_5_main_main_default, lv_color_make(0xe6, 0xe2, 0xe6));
	lv_style_set_bg_grad_dir(&style_screen4_sw_5_main_main_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_5_main_main_default, 255);
	lv_obj_add_style(ui->screen4_sw_5, &style_screen4_sw_5_main_main_default, LV_PART_MAIN|LV_STATE_DEFAULT);

	//Write style state: LV_STATE_CHECKED for style_screen4_sw_5_main_indicator_checked
	static lv_style_t style_screen4_sw_5_main_indicator_checked;
	if (style_screen4_sw_5_main_indicator_checked.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_5_main_indicator_checked);
	else
		lv_style_init(&style_screen4_sw_5_main_indicator_checked);
	lv_style_set_radius(&style_screen4_sw_5_main_indicator_checked, 100);
	lv_style_set_bg_color(&style_screen4_sw_5_main_indicator_checked, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_color(&style_screen4_sw_5_main_indicator_checked, lv_color_make(0x21, 0x95, 0xf6));
	lv_style_set_bg_grad_dir(&style_screen4_sw_5_main_indicator_checked, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_5_main_indicator_checked, 255);
	lv_obj_add_style(ui->screen4_sw_5, &style_screen4_sw_5_main_indicator_checked, LV_PART_INDICATOR|LV_STATE_CHECKED);

	//Write style state: LV_STATE_DEFAULT for style_screen4_sw_5_main_knob_default
	static lv_style_t style_screen4_sw_5_main_knob_default;
	if (style_screen4_sw_5_main_knob_default.prop_cnt > 1)
		lv_style_reset(&style_screen4_sw_5_main_knob_default);
	else
		lv_style_init(&style_screen4_sw_5_main_knob_default);
	lv_style_set_radius(&style_screen4_sw_5_main_knob_default, 100);
	lv_style_set_bg_color(&style_screen4_sw_5_main_knob_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_color(&style_screen4_sw_5_main_knob_default, lv_color_make(0xff, 0xff, 0xff));
	lv_style_set_bg_grad_dir(&style_screen4_sw_5_main_knob_default, LV_GRAD_DIR_VER);
	lv_style_set_bg_opa(&style_screen4_sw_5_main_knob_default, 255);
	lv_obj_add_style(ui->screen4_sw_5, &style_screen4_sw_5_main_knob_default, LV_PART_KNOB|LV_STATE_DEFAULT);

	//Init events for screen
	events_init_screen4(ui);
}